%### MKSHP.SL

% This file is used to generate compiled Sheep on Codemist Standard
% Lisp (CSL) or Rsheep on CSL based Reduce.

(SETQ !*INT NIL)                % Batch
(SETQ !*COMP NIL)
(LOAD "../SEARSH")              % Set search list for making Sheep.
(IFP !*RSHEEP (LOAD SHBOOT))    % For Rsheep only.
(MODULOAD SHIMP1)               % Implementation specific code, part 1.
(LOAD SHPMAC)                   % Macros. For compilation only.
(LOAD SHEEPI)                   % Sheep, implementation independent.
(MODULOAD SHIMP2)               % Implementation specific code, part 2.
(LOAD SHLOD)                    % Some initialisation.
(IFP !*RSHEEP (MODULOAD SHPFIN)) % For Rsheep only.
%(MKSIDEFAP CORD)               % Make Cord side module.
(FOREACH FN IN LOCALFUNCTIONS!* DO (REMOB FN))  % Remove from oblist.
(SETQ LOCALFUNCTIONS!* NIL)     % Release list storage.
(SAVERUN NIL)                   % Save the image.

%### MKSHP.SL end
