%### SHIMP1.SL

% Implementation specific code for Sheep, part 1, functions that can
% be defined before loading the implementation independent code.
% Cambridge University Lisp version.

% This file was created by dividing shcmbl into two parts shimp1 and
% shimp2 to be loaded before and after the bulk of the Sheep code. JEA.

(SETGLOBALS
 ((ALT!*        (ASCII 27)))    % Altmode (escape) character.
 ((FF!*         !$FF!$)) )      % Form-feed.

(NOTLOADTIME (REMFLAG '(BIGGID2 TSTPARSW) 'LOSE))

(SAMEDEF BIGGID2 ORDERP)        % Always use lexical ordering of ids.

(DS TSTPARSW (!&REST L) (NOT (XZEROP (ILOGAND PARSW!* (PARSW . L)))))

(NOTLOADTIME (FLAG '(BIGGID2 TSTPARSW TSTBIT IDVALUE) 'LOSE))

(INCLUDE "CURAT.SL")            % Use Culisp rationals

%### SHIMP1.SL end
