%### LARITH.SL

% larith.sl was once used to provide Sheep with complex arithmetic
% where a rational complex number was represented with three integers
% a, b and c as (a b . c) where a and b are the nominators for the
% real and imaginary parts respectively and c the common denominator.
% E.g. -1/2+i/3 was represented as (-3 2 . 6) .
% This module have not been updated and will therefore not work. JEA.

(SETGLOBALS RELN!$ RELN1!$ DEN!$ DEN1!$ IMN!$ IMN1!$ !$FLOATSW)

(DE SPLUS (X Y) (PROGN (DGETNUMRI X) (DGETNUMR Y) (DOADD) (RETARITH)))

(DE STIMES (X Y) (PROGN (DGETNUMRI X) (DGETNUMR Y) (DOMUL) (RETARITH)))

(DE LPLUS (L) (SLET ((!*!*PLUSSW T)) (LARITH L)))

(DE LTIMES (L) (SLET (!*!*PLUSSW) (LARITH L)))

(DE LARITH (NR)
 (COND
  ((NULL NR) (COND (!*!*PLUSSW 0) (T 1)))
  (T (DGETNUMRI (CAR NR))
     (FOREACH X IN (CDR NR) DO (DOARITH X))
     (RETARITH) ) ))

% Renamed because this is a Sheep-specific DENQ. JEA
(DE SDENQ (SNU)
 (COND
  ((NOT (PAIRP SNU)) NIL)
  ((NUMBERP (UNPUSH SNU)) SNU)
  (T (CDR SNU)) ) )

(DE NOM (SNU)
 (COND
  ((NOT (PAIRP SNU)) SNU)
  ((NUMBERP (CDR SNU)) (CAR SNU))
  ((CDDR SNU) (LIST (CAR SNU) (CADR SNU)))
  (T SNU) ) )

(DE RETARITH NIL (COND
  ((AONEP DEN!$)
   (COND
    ((NOT (ZEROP IMN!$)) (LIST RELN!$ IMN!$))
    ((NOT !$FLOATSW) RELN!$)
    ((ZEROP RELN!$) 0)
    ((ONEP RELN!$) 1)
    (T RELN!$) ) )
  ((AZEROP IMN!$) (CONS RELN!$ DEN!$))
  (T (CONSA RELN!$ IMN!$ DEN!$)) ))

(DE DGETNUMRI (SNU) (PROGN
  (SETQ IMN!$ 0)
  (SETQ DEN!$ 1)
  (COND
   ((NUMBERP SNU) (SETQ RELN!$ SNU))
   (T (SETQ RELN!$ (CAR SNU))
      (COND
       ((NUMBERP (CDR SNU)) (SETQ DEN!$ (CDR SNU)))
       (T (SETQ IMN!$ (CADR SNU))
          (COND ((CDDR SNU) (SETQ DEN!$ (CDDR SNU)))) ) ) ) )
  (COND ((AND (SETQ !$FLOATSW (FLOATP RELN!$)) (AZEROP IMN!$))
         (SETQ IMN!$ 0.0) )) ))

(DE DGETNUMR (SNU) (PROGN
  (SETQ DEN1!$ 1)
  (SETQ IMN1!$ 0)
  (COND
   ((NUMBERP SNU) (SETQ RELN1!$ SNU))
   (T (SETQ RELN1!$ (CAR SNU))
      (COND
       ((NUMBERP (UNPUSH SNU)) (SETQ DEN1!$ SNU))
       (T (SETQ IMN1!$ (CAR SNU))
          (COND ((UNPUSH SNU) (SETQ DEN1!$ SNU))) ) ) ) )
  (COND
   ((FLOATP RELN1!$)
    (COND ((AZEROP IMN1!$) (SETQ IMN1!$ 0.0)))
    (COND ((NOT !$FLOATSW)
           (SETQ !$FLOATSW T)
           (SETQ RELN!$ (QUOTIENT (FLOAT RELN!$) DEN!$))
           (SETQ IMN!$ (QUOTIENT (FLOAT IMN!$) DEN!$))
           (SETQ DEN!$ 1) )) )
   ((NOT !$FLOATSW) NIL)
   ((NOT (AONEP DEN1!$))
    (SETQ DEN1!$ (FLOAT DEN1!$))
    (SETQ RELN1!$ (QUOTIENT RELN1!$ DEN1!$))
    (SETQ IMN1!$ (QUOTIENT IMN1!$ DEN1!$))
    (SETQ DEN1!$ 1) )
   (T (SETQ RELN1!$ (FLOAT RELN1!$)) (SETQ IMN1!$ (FLOAT IMN1!$))) ) ))

(DE DOARITH (SNU)
 (PROGN (DGETNUMR SNU) (COND (!*!*PLUSSW (DOADD)) (T (DOMUL)))) )

(DE DOADD NIL
 (COND
  ((EQN DEN!$ DEN1!$)
   (SETQ RELN!$ (PLUS RELN!$ RELN1!$))
   (SETQ IMN!$ (PLUS IMN!$ IMN1!$))
   (CHKGCDN DEN!$) )
  (T (SLET ((A (GCD DEN1!$ DEN!$)) DENX)
      (COND
       ((AONEP A) (SETQ DENX DEN!$) (SETQ DEN!$ (TIMES DEN1!$ DEN!$)))
       (T (SETQ DENX (QUOTIENT DEN!$ A))
          (SETQ DEN!$ (TIMES DEN1!$ DENX))
          (SETQ DEN1!$ (QUOTIENT DEN1!$ A)) ) )
      (SETQ RELN!$ (PLUS (TIMES RELN!$ DEN1!$) (TIMES RELN1!$ DENX)))
      (SETQ IMN!$ (PLUS (TIMES IMN!$ DEN1!$) (TIMES IMN1!$ DENX)))
      (CHKGCDN A) )) ) )

(DE CHKGCDN (GD)
 (COND
  ((AND (AZEROP RELN!$) (AZEROP IMN!$)) (SETQ DEN!$ 1))
  ((NOT (AONEP GD))
   (SETQ GD (GCD3 RELN!$ IMN!$ GD))
   (COND ((NOT (AONEP GD))
          (SETQ RELN!$ (QUOTIENT RELN!$ GD))
          (SETQ IMN!$ (QUOTIENT IMN!$ GD))
          (SETQ DEN!$ (QUOTIENT DEN!$ GD)) )) ) ) )

(DE GCD3 (X Y Z)
 (COND
  ((AZEROP X) (COND ((AZEROP Y) 1) (T (GCD Y Z))))
  ((AZEROP Y) (GCD X Z))
  ((AONEP (SETQ X (GCD X Z))) 1)
  (T (GCD Y X)) ) )

(DE DOMUL NIL
 (COND
  ((EQN DEN!$ DEN1!$) (DOMULE))
  (T (SLET
      ((A (COND ((AONEP DEN1!$) 1) (T (GCD3 RELN!$ IMN!$ DEN1!$)))))
      (COND ((NOT (AONEP A))
             (SETQ RELN!$ (QUOTIENT RELN!$ A))
             (SETQ IMN!$ (QUOTIENT IMN!$ A))
             (SETQ DEN1!$ (QUOTIENT DEN1!$ A)) ))
      (SETQ A (COND ((AONEP DEN!$) 1) (T (GCD3 RELN1!$ IMN1!$ DEN!$))))
      (COND ((NOT (AONEP A))
             (SETQ RELN1!$ (QUOTIENT RELN1!$ A))
             (SETQ IMN1!$ (QUOTIENT IMN1!$ A))
             (SETQ DEN!$ (QUOTIENT DEN!$ A)) ))
      (DOMULE) )) ) )

(DE DOMULE NIL
 (SLET ((A (COND ((NOT (OR (ZEROP IMN1!$) (ZEROP IMN!$)))
                  (TIMES IMN!$ IMN1!$) ))))
  (COND ((NOT (AONEP DEN1!$)) (SETQ DEN!$ (TIMES DEN!$ DEN1!$))))
  (COND
   (A (SETQ IMN!$ (PLUS (TIMES IMN!$ RELN1!$) (TIMES IMN1!$ RELN!$))))
   ((NOT (ZEROP IMN1!$)) (SETQ IMN!$ (TIMES IMN1!$ RELN!$)))
   ((NOT (ZEROP IMN!$)) (SETQ IMN!$ (TIMES IMN!$ RELN1!$))))
  (SETQ RELN!$ (TIMES RELN!$ RELN1!$))
  (COND
   (A (SETQ RELN!$ (DIFFERENCE RELN!$ A)) (CHKGCDN DEN!$))
   ((AND (AZEROP RELN!$) (AZEROP IMN!$)) (SETQ DEN!$ 1)))))

(DE SNUM (NOMX DENX) (SNUMX NOMX 0 DENX))

(DE SNUMX (RELX IMNX DENX)
 (COND
  ((AZEROP DENX) (ERRORFT 490 "Zero denominator"))
  ((OR (FLOATP RELX) (FLOATP IMNX) (FLOATP DENX))
   (SETQ DENX (FLOAT DENX))
   (SNUMX1
    (QUOTIENT RELX DENX)
    (COND ((AZEROP IMNX) 0) (T (QUOTIENT IMNX DENX)))
    1) )
  ((MINUSP DENX) (SNUMX1 (MINUS RELX) (MINUS IMNX) (MINUS DENX)))
  (T (SNUMX1 RELX IMNX DENX)) ) )

(DE SNUMX1 (RELNX IMNX DENX) (PROGN
  (SETQ RELN!$ RELNX)
  (SETQ IMN!$ IMNX)
  (SETQ DEN!$ DENX)
  (CHKGCDN DEN!$)
  (RETARITH) ))

(DE SRECIP (SNU) (SEXPT SNU -1))

(DE SMINUSP (SNU)
 (MINUSP (COND
   ((NUMBERP SNU) SNU)
   (T (CAR SNU)) )) )

(DE SMINUS (X)
 (COND
  ((NUMBERP X) (MINUS X))
  ((NUMBERP (CDR X)) (CONS (MINUS (CAR X)) (CDR X)))
  (T (CONSA (MINUS (CAR X)) (MINUS (CADR X)) (CDDR X))) ) )

% BAS^EX where BAS and EX are SNUMs and at least one of them is a
% floating point number.
% Can be improved for systems where second argument to EXPT not
% have to be an integer or have EXP and LOG defined. Added by JEA.
(DE SFEXPT (BAS EX) (COND
  ((FIXP EX) (EXPT BAS EX))             % EX integer.
  (T (XMKEXPT BAS EX)) ))

(DE SEXPT (BAS EX)
 (SLET ((SW (MINUSP EX)))
  (COND (SW (SETQ EX (MINUS EX))))
  (COND
   ((NUMBERP BAS)
    (SETQ BAS (EXPT BAS EX))
    (COND
     ((NOT SW) BAS)
     ((ZEROP BAS) (SNUM 1 0))
     ((FLOATP BAS) (QUOTIENT 1 BAS))
     ((OR (AONEP BAS) (AEQN BAS -1)) BAS)
     ((MINUSP BAS) (CONS -1 (MINUS BAS)))
     (T (CONS 1 BAS)) ) )
   ((NUMBERP (CDR BAS))
    (SETQ DEN!$ (EXPT (CDR BAS) EX))
    (SETQ BAS (EXPT (CAR BAS) EX))
    (COND
     ((NOT SW) (CONS BAS DEN!$))
     ((AONEP BAS) DEN!$)
     ((AEQN BAS -1) (MINUS DEN!$))
     ((MINUSP BAS) (CONS (MINUS DEN!$) (MINUS BAS)))
     (T (CONS DEN!$ BAS)) ) )
   (T (SETQ RELN!$ (SETQ RELN1!$ (CAR BAS)))
      (SETQ IMN!$ (SETQ IMN1!$ (CADR BAS)))
      (SETQ DEN!$ (SETQ DEN1!$ 1))
      (SETQ BAS (CDDR BAS))
      (REPEATS (SUB1 EX) (DOMULE))
      (COND (BAS (SETQ DEN1!$ (EXPT BAS EX))))
      (COND
       (SW (SETQ IMN!$ (MINUS IMN!$))
           (SETQ DEN!$ (PLUS (EXPT RELN!$ 2) (EXPT IMN!$ 2)))
           (COND
            (BAS (SETQ RELN!$ (TIMES RELN!$ DEN1!$))
                 (SETQ IMN!$ (TIMES IMN!$ DEN1!$)) )
            ((FLOATP DEN!$)
             (SETQ RELN!$ (QUOTIENT RELN!$ DEN!$))
             (SETQ IMN!$ (QUOTIENT IMN!$ DEN!$))
             (SETQ DEN!$ 1) ) ) )
       (BAS (SETQ DEN!$ DEN1!$)) )
      (SETQ DEN!$ (CHKGCDN DEN!$))
      (RETARITH) ) ) ) )

(DE RQUOTIENT (X)
 (COND
  ((NOT (PAIRP X)) X)
  ((NUMBERP (CDR X)) (QUOTIENT (CAR X) (CDR X)))
  ((CDDR X) (QUOTIENT (CAR X) (CDDR X)))
  (T (CAR X)) ) )

(DE RREMAINDER (X)
 (COND
  ((DENQ X)
   (DGETNUMRI X)
   (SETQ RELN!$ (REMAINDER RELN!$ DEN!$))
   (RETARITH) )
  (T 0) ) )

(DE MIN1BAS (EX)
 (COND
  ((NOT (PAIRP EX)) (COND ((EVENP EX) 1) (T -1)))
  (T (SLET ((BAS -1) SW)
      (DGETNUMRI EX)
      (COND
       ((AZEROP IMN!$) (SETQ IMN1!$ NIL))
       (T (SETQ IMN1!$ IMN!$) (SETQ IMN!$ (SETQ RELN1!$ 0))
          (SETQ DEN!$ (CHKGCDN (SETQ DEN1!$ DEN!$))) ) )
      (SETQ SW (NOT (EVENP (QUOTIENT RELN!$ DEN!$))))
      (COND ((MINUSP (SETQ RELN!$ (REMAINDER RELN!$ DEN!$)))
             (SETQ SW (NOT SW)) (SETQ RELN!$ (PLUS RELN!$ DEN!$)) ))
      (COND
       ((EVENP RELN!$) (SETQ RELN!$ 0) (SETQ DEN!$ 1))
       ((NOT (EVENP DEN!$)) (SETQ SW T) (SETQ RELN!$ 0) (SETQ DEN!$ 1))
       (T (SETQ BAS IMNT!*) (SETQ DEN!$ (QUOTIENT DEN!$ 2))
          (COND (IMN1!$ (SETQ DEN1!$ (QUOTIENT DEN1!$ 2)))) ) )
      (COND (IMN1!$ (DOADD)))
      (COND
       ((AZEROP (SETQ EX (RETARITH))) (COND (SW -1) (T 1)))
       ((AONEP EX) (COND (SW (SMINUS BAS)) (T BAS)))
       (SW (LIST 'TIMES -1 (MKSEXPT BAS EX)))
       (T (MKSEXPT BAS EX)) ) )) ) )

(DE IMBAS (EX) (SIEDN IMNT!* EX))

(DE VNUM (NUM)
 (SLET (DSH DSH1 INM CPL RT)
  (DGETNUMRI NUM)
  (COND ((MINUSP RELN!$) (SETQ DSH (SETQ RELN!$ (MINUS RELN!$)))))
  (COND ((NOT (AZEROP IMN!$))
         (COND ((MINUSP IMN!$)
                (SETQ IMN!$ (MINUS IMN!$)) (SETQ DSH1 (NOT DSH)) ))
         (SETQ INM (VATM 'I))
         (SETQ IMN!$ (COND ((ONEP IMN!$) INM) (T (CONS IMN!$ INM))))
         (SETQ RELN!$ (COND
           ((ZEROP RELN!$) (SETQ DSH DSH1) IMN!$)
           (T (SETQ CPL T)
              (CONSA RELN!$ (COND (DSH1 '!-) (T '!+)) IMN!$) ) )) ))
  (COND ((NOT (AONEP DEN!$))
         (COND (CPL (SETQ RELN!$ (ATPAR RELN!$)) (SETQ CPL NIL)))
         (SETQ RT RATPAR)
         (SETQ RELN!$ (CONSA RELN!$ '!/ DEN!$)) ))
  (COND
   (CPL (SETPARSW CPLXPAR TIMPAR DIFPAR BASPAR))
   (RT (SETPARSW TIMPAR DIFPAR BASPAR))
   (T (SETPARSW DIFPAR BASPAR)) )
  (COND (DSH (CONS '!- RELN!$)) (T RELN!$)) ) )

(DE BIGGSNU (X Y)
 (COND
  ((NOT NORATORDN) (BIGGSNRT X Y))  % JEA
  ((ATOM X) (COND ((ATOM Y) (BIGGSN1 X Y)) (T 'INSERT)))
  ((ATOM Y) 'GOON)
  (T (BIGGSN1 (CAR X) (CAR Y))
     (COND
      ((ATOM (UNPUSH X)) (COND
        ((ATOM (UNPUSH Y)) (BIGGSN1 X Y))
        (T 'INSERT) ))
      ((ATOM (UNPUSH Y)) 'GOON)
      (T (BIGGSN1 (CAR X) (CAR Y))
         (COND
          ((EQ (UNPUSH X) (UNPUSH Y)) NIL)
          ((NULL X) 'INSERT)
          ((NULL Y) 'GOON)
          (T (BIGGSN1 X Y)) ) ) ) ) ) )

(DE BIGGSNRT (XR YR)
 (SLET ((XI 0) (YI 0) (X 1) (Y 1))
  (COND ((PAIRP XR)
         (SETQ X (CDR XR))
         (SETQ XR (CAR XR))
         (COND ((PAIRP X) (SETQ XI (CAR X)) (SETQ X (OR (CDR X) 1)))) ))
  (COND ((PAIRP YR)
         (SETQ Y (CDR YR))
         (SETQ YR (CAR YR))
         (COND ((PAIRP Y) (SETQ YI (CAR Y)) (SETQ Y (OR (CDR Y) 1)))) ))
  (COND
   ((EQN X Y) (OR (BIGGSN1 XR YR) (BIGGSN1 XI YI)))
   (T (OR (BIGGSN1 (TIMES XR Y) (TIMES YR X))
       (BIGGSN1 (TIMES XI Y) (TIMES YI X)) )) ) ) )

(SETQ IMNT!* '(0 1))

%### LARITH.SL end
