%### MKLAM.SL

% This file is used to generate compiled LAM, i.e. the algebra part of
% Sheep without support for tensors, from compiled PSL-based Sheep Lisp.

(SETQ !*INT NIL)                % Batch
(LOAD "../SEARSH")              % Set search list for making Sheep.
(IFP !*RSHEEP (LOAD SHBOOT))    % For Rsheep only.
(SETQ !*COMP T)                 % For compilation only.
(LOAD SHIMP1)                   % Implementation specific code, part 1.
(LOAD SHPMAC)                   % Macros. For compilation only.
(LOAD LAMI)                     % The Lam source code.
(LOAD SHIMP2)                   % Implementation specific code, part 2.
(SETQ !*COMP NIL)               % Stop compiling.
(LOAD SHLOD)                    % Some initialisation.
(IFP !*RSHEEP (LOAD SHPFIN))    % For Rsheep only.
(IFP !*RSHEEP                   % Save the image.
 (SAVERUN RLAM)
 (SAVERUN LAM) )

%### MKLAM.SL end
