%### SHPMC.SL

(CMMACRO SETENQQ (!&DS X Y) (SETEN 'X 'Y))

(CMMACRO XMEXPT (!&DS BAS EX)
 (SLET ((VR!$ EX)) (COND
   ((AZEROP VR!$) 1)
   ((AONEP VR!$) BAS)
   (T (SMEXPT BAS VR!$)) )) )

(CMMACRO XMMULTC (SW MSW NL !&REST L)
 (SLET ((BODY (LIST '(VR!$1 VR!$2 MINSW) 'PROG)))
  (COND (MSW (XPUSH BODY '(SETQ MINSW T))))
  (FOREACH X IN L DO (SETQ BODY (CONSA
    '(XPUSH VR!$2 VR!$1)
    (LIST 'COND (LIST (LIST 'AZEROP (LIST 'SETQ 'VR!$1 X)) '(RETURN 0)))
    BODY )))
  (REVERSIP (RPLACA BODY
    (LIST 'RETURN
     (LIST 'SMMULTC '(CONS VR!$1 VR!$2) NL 'MINSW SW) ) )) ) )

(CMMACRO XMDOMULC (!&DS X Y MSW)
 (SLET ((MINSW MSW) VR!$1 VR!$2)
  (COND
   ((OR (AZEROP (SETQ VR!$1 X)) (AZEROP (SETQ VR!$2 Y))) 0)
   (T (DOMULCW VR!$1 VR!$2 MINSW)) ) ) )

(CMMACRO XMDFMQ (!&DS X Y VR VT MSW)
 (SLET ((MINSW MSW) VR!$1 VR!$2)
  (COND
   ((OR (AZEROP (SETQ VR!$1 X)) (SNUMP (SETQ VR!$2 Y))) 0)
   (T (IDFMQ VR!$1 VR!$2 VR VT MINSW)) ) ) )

(CMMACRO XMDFMQL (!&DS X Y VRL VT MSW)
 (SLET ((MINSW MSW) VR!$1 VR!$2)
  (COND
   ((OR (AZEROP (SETQ VR!$1 X)) (SNUMP (SETQ VR!$2 Y))) 0)
   (T (IDFMQL VR!$1 VR!$2 VRL VT MINSW)) ) ) )

(CMMACRO XMDFMQ2L (!&DS X Y VR1L VT1 VR2L VT2 MSW)
 (SLET ((MINSW MSW) VR!$1 VR!$2)
  (COND
   ((OR (SNUMP (SETQ VR!$1 X)) (SNUMP (SETQ VR!$2 Y))) 0)
   (T (IDFMQ2L VR!$1 VR!$2 VR1L VT1 VR2L VT2 MINSW)) ) ) )

(CMMACRO XMPLUS (!&REST L)
 (CONS 'SHCOLLECT (FOREACH X IN L COLLECT (LIST 'SMADDTERM X))) )

(CMMACRO XMRTIMES (!&DS X Y)
 (SLET ((VR!$1 X))
  (COND
   ((AZEROP VR!$1) 0)
   (T (SNUTIM VR!$1 Y)) ) ) )

%### SHPMC.SL end
