%### MKSL.SL ========================================================
%
%       MKSL.SL
%       -------
%
%       Copyright (c) 1992 - 2011 by Jan E. Aman,
%       Department of Physics, Stockholm University,
%       SE-106 91  Stockholm, Sweden.
%
%       This file contains the commands executed in Codemist
%       Standard Lisp (CSL) to build a compiled Sheep Lisp.
%
%====================================================================

(SETQ !*RAISE NIL)

(SETQ !*COMP NIL)

(COND ((NOT (GETD 'INCLUDE)) (RDF "ldint.sl")))

(SETQ !*COMP T)

(INCLUDE "exfn1.sl")
(INCLUDE "exint.sl")
(INCLUDE "exfn2.sl")
(INCLUDE "printf.sl")
(INCLUDE "load.sl")
%(INCLUDE "../newnam.sl")

%(MODULE 'SIDMOD) (INCLUDE "sidmod.sl") (ENDMODULE)   % JEA

(SETQ !*COMP NIL)

(FOREACH FN IN LOCALFUNCTIONS!* DO
 (COND ((CODEP (GETFN FN)) (REMOB FN))) )       % Remove from oblist.
(SETQ LOCALFUNCTIONS!* NIL)             % Release list storage.

(SETQ DATE!* (DATETIME))

(SAVERUN NIL)

%### MKSL.SL end
