%### ATARI.SL =======================================================
%
%       ATARI.SL
%       --------
%
%       Copyright (C) 1987 by Lars Hornfeldt and Jan E. Aman
%       Institute of Theoretical Physics,
%       Vanadisvagen 9, S-113 46 Stockholm, Sweden.
%
%       This file contains, for the ATARI ST series of computers,
%       initial adoptions and symbols that are used
%       throughout in the code for SLISP, SHEEP, CLASSI and STENSOR.
%
%       Atari specific code is usually marked with "%:ATari"
%       and is obtained by test of (EQ 'ATARI (SYSTYPE 'MACHINE))
%       or during bootstrap of (GETD 'EDIT).
%
% If you haven't got a hard disk (you would be better off if you had
% one) there are two ways to start lisp based systems:
% 1)  lisp.ttp and image on same floppy
% 2)  lisp.tos on floppy A (that must NOT have any image-dir!)
%       -causing request to insert floppy B with image.
%
% 1) The slsrc floppy should use method 1, ie have both lisp.ttp on it,
%    and an image directory. Clicking lisp.ttp, and typing to the
%    ttp-question:
%          image=image          -will use that directory.
%
% 2) ALL OTHER FLOPPYS (eg shpsrc and stssrc) SHOULD NOT have any lisp
%    on it, ie use method 2
%
%       For hard disks, see sstensor.ini
%
%====================================================================

% Installation dependent directory specifications. Change the
% following two specifications, in particular the disk (partition)
% e: to agree with your Atari disk.
(SETQ CURRENTDIR!* "e:\slsrc\culisp") %:ATARI %:update this!! <<<<*****
(SETQ TOPDIR!* "e:")                  %:ATARI %:update this!! <<<<*****

%### ATARI.SL end
