%### EXINT.SL =======================================================
%
%       EXINT.SL
%       --------
%
%       Copyright (c) 1984 by Inge Frick, Institute of Theoretical
%       Physics, Vanadisvagen 9, S-113 46 Stockholm, Sweden and
%       Jan E. Aman, School of Mathematical Sciences, Queen Mary
%       College (U. of London), Mile End Road, London E1 4NS, UK.
%
%       This file contains some changes to EXINTI.SL that adapts it to
%       Cambridge Lisp.
%
%====================================================================

(DFEXPR ERRSET (ERS!*BODY ERS!&SW)
 (PLET ((!*ERRMSG (EVAL ERS!&SW)) (SFVR!& (CAPTURESFSTKS)))
  (UNBINDSFSTKS SFVR!& (ERRORSET ERS!*BODY !*ERRMSG)) ) )

(FLAG '(ERRSET) 'LOSE)          % Defined in the present file.

% WHILE defined in Cambridge Lisp but replaced for Reduce.
(IFP (NOT !*RSHEEP) (FLAG '(WHILE) 'LOSE))
% (FLAG '(WHILE) 'LOSE)

(INCLUDE "../exinti.sl")

% WHILE defined in Cambridge Lisp but replaced for Reduce.
(IFP (NOT !*RSHEEP) (REMFLAG '(WHILE) 'LOSE))
% (REMFLAG '(WHILE) 'LOSE)

(REMFLAG '(ERRSET) 'LOSE)

%### EXINT.SL end
