%### EXINT.SL =======================================================
%
%       EXINT.SL
%       --------
%
%       Copyright (c) 1982 by Inge Frick, Institute of Theoretical
%       Physics, Vanadisvagen 9, S-113 46 Stockholm, Sweden.
%
%       This file contains some changes to EXINTI.SL that adapts it to
%       Franz Lisp.
%
%====================================================================

(DE MAPRPLC (L FN)
 (map (FUNCTION (LAMBDA (X) (RPLACA X (FUNCALL FN (CAR X))))) L) )

(DE MAPRPL (L FN)
 (map (FUNCTION (LAMBDA (X) (RPLACA X (FUNCALL FN X)))) L) )

(DE undef!-func!-handler (X)
 (SLET ((FIL (GET (SETQ X (CAR (CDDDDR X))) 'autoload)))
  (COND (FIL (MLOAD FIL) (COND ((FNP X) (NCONS X))))) ) )

(PUT 'trace 'autoload 'TRACE)

(PUT 'PRETTYPRINT 'autoload 'GRIND)

(PUT 'GRIND 'autoload 'GRIND)

(PUT 'CREFOUT 'autoload 'RCREF)

(PUT 'PATCH 'autoload 'PATCH)

(eval!-when (eval compile)
 (FLAG '(MAPRPL MAPRPLC) 'LOSE)         % Defined in this file
 (FLAG '(THROWQ CATCHQ ERRSET ERS!*BODY UNWINDPROTECT PROG1)
       'LOSE) ) % Defined in exfn2.sl.

(INCLUDE "../exinti.sl")        

(eval!-when (eval compile)
 (REMFLAG '(MAPRPL MAPRPLC) 'LOSE)
 (REMFLAG '(THROWQ CATCHQ ERRSET ERS!*BODY UNWINDPROTECT PROG1)
          'LOSE) )

%### EXINT.SL end
