
							Stockholm, Dec 1992
Dear Sir

	Thank you for your enquiery regarding SHEEP/CLASSI/STENSOR.

They work together and with Reduce(for GCD,INTegration). Their specialties are:
SHEEP -components of tensors
CLASSI -fication of metrics, Petrov types.
STENSOR-"SymbolicTENSORs"=having letter indices. General noncommuting algebra.
	Sumsubstitution eg for trigsimplification. Diskusage for BIG work.
Please request separate further information about the features in your
area of interest. The below only describes the technical availability.

                MACHINES/LISPS THAT RUN THIS SYSTEM
                ===================================
MACHINE:  	Requiring what LISP:		Relative speed:	Comment:
VAX(VMS/U-ix)	PSL(Reduce) or Franz		Eg 750:1  780:1.2 (Divide
Orion (HLH ltd)	Cambridge Lisp			       1   	-with users!)
ATARI ST  	Cambridge Lisp			      1/9  	(All for you)
AMIGA(As Atari,but untested) Cambridge Lisp	      1/9  	(All for you)
Sun 3,4,Sparcs etc.	PSL (or Franz?)		 from  4 (+>10 for disk i/o!)
DEC/VAX workstations.	PSL			 from  4 (+>10 for disk i/o!)
Other	  -"-	from eg Apollo should work similarly.
IBM 3090=If Needed.	PSL			   ca 50??
Desktops IBM 386,486 and MacIntosh:Could help you set up on PSL,rather simple.

Possible on request:	Eg Apollo, Cray, or most machines with PSL(Reduce).
			Rather similar to Atari: Acorn Archimedes/NS32016.

DO YOU HAVE REDUCE?  This is the first question - whether you have some
	machine with the computer algebra system REDUCE on it. If so,
	it also has "Bare-PSL" which REDUCE runs on, and which also is
	the most common platform for us.

IF YES,HAVE REDUCE:	-then it's preferable I send STENSOR,
	if you want the most recent version.

IF NO,HAVEN'T REDUCE:
	a:Get it separate (Valuable;can eg work together with STENSOR)
	b:If you don't need/want Reduce, you can get both SHEEP../STENSOR
	*AND* Bare-PSL, from Malcolm MacCallum, QMW, London (mm@qmw.ac.uk)
	who has aquired licence to distribute Bare-PSL for this purpose.
	(He is also one of the authors of a book on SHEEP/CLASSI/STENSOR).

	To be complete, there are currently 3 suitable lisp-alternatives:
	Franz Lisp (comes eg with Vaxyma), now free(?) but outdated.
	Portable Standard Lisp, 'PSL'   (USD 200),
		or best: get REDUCE for USD 500 (includes PSL)
	Cambridge (University) Lisp	(USD 2-300?)
	Coming: Codemist Standard Lisp, 'CSL'   (USD 300?),
Later possibly porting to: LeLisp(fast,costly), and
	CMU Common Lisp (free) which has window system(dropdown menus)

Of MACHINES, a SUN or DEC workstation (with Reduce) has the most flexible
	memory. Next to those, VAXes are most common; any OS.

When ordering, specify your:
	Machine + Operating system:
	Possibly FTP, else:
	 Tape formate: (TAR or VMS-BACKUP).
	 Tape density: (800, 1600, 6250 BPI. XABYTE 8mm cartridge)
	Lisp system: (Cambridge, PSL or Franz)
	Whether you have got REDUCE or not:

IBM 3090: REDUCE exists in two versions; one based on PSL, and
======== one on a too old SLISP. Thus REDUCE isn't enough;
	You must ensure	it is based on *PSL*.
	Eg the one in LYON (FRCPN11) has NOT PSL, and is thus not feasible.

ATARI/AMIGA:	Could send DS/DD floppys, and also later correspondence and
===========	complementary upgrades could use the very convenient floppys.
	Four Mbyte allow up to ca 10.000 term expressions in RAM.
	1Mb hold 2000 terms, despite that the full code would fill 3Mb! But:
	1:the CU-lisp reuses the space used by 100 compiled 'modules'
	  when expression size so request. When code in such a module is
	  called, it is reloaded (and maybe 1 or 2 other modules dropped).
	2:Above moduleswapping don't handle strings and S-expressions,
	  so STENSOR takes care of these self; eg all error- and warning
	  messages live in files, and are individually looked up and
	  loaded only when needed. Such 'temporary items' also include eg
	  help and menus/association lists in code. These items compete on a
	  common list, the least used are dropped from RAM when crammed.
	3:There are ca 50 autoloading files for rarely used code.

	   In all,above has made the initial image a mere 330k, while the rest
	   of the code is loaded/unloaded dynamically depending on need/space.
	4:	The automatic diskusage/bucketing is a great leverage that
	   magnifies whatever few kbyte workspace in RAM you have, to handle
	   million term expressions. For that size, you need a hard disk.

	RUNNING FROM FLOPPIES is possible by starting up from one, and then
	changing to either of a few secondary. The essentials precisely fits
	with special 830kb formatting.


COST:	SHEEP/CLASSI is hitherto free (except for tape, ca $50) but the
====	STENSOR code is so large that a symbolic contribution of $200 extra
is welcome. I could email an invoice in tex-form, or send a signed hardcopy,
to help your administration. The total payment corresponding to US Dollar 250
could be sent:
>>	as check by mail,

>>	or to the bank account nbr: (11 60) 241 081 521
	-at the office: SHB (Svenska Handelsbanken)
			Box 1057
			S-171 21    SOLNA,	S W E D E N

	Checks cost ca USD 7-8 for both sender and receiver.
	One can avoid this by going to a (main?) postoffice,
	and use the postal currency (transfer) account service,
	with a postal cheque (giro) form, sending to my:

>> Personal postal cheque account,	(postgiro) number: 433 20 98-5

The accounts are associated with my home address (phone +46 8 837114):
			Lars  Hornfeldt
			Vastra vagen 11B, 6tr
			S-171 46    SOLNA,	S W E D E N

Notify me of transfer,so I can send off documentation and latest version.

Sincerely Yours,
			Lars  Hornfeldt
			Institute of Theoretical Physics
			University of Stockholm
			Vanadisvagen 9
			S-113 46   STOCKHOLM,	S W E D E N

Best contact is through email.	Some periods I am in eg Rome.
	Email (BITNET, internet):	Phone:		Fax:	Telex:
Sthlm:	LH@SESUF51   lh@vand.physto.se	+46 8 837114	347817  15433 FYSTO S
Rome:		stensor@mvrmg9.cern.ch	+39 6 49914299	4454992
