%### FOIN.SL

(LOCALFUNCTIONS FSYNER FOADD FOINGE ISCOL RFOI RFOIE NARYA RMIN
                RPRO RINV RPEXP RPDIF RPATM IRPATM XRPATM RTRIM
                QFOER FEVAL FDORED FDORE1 FDORELIS )

(SETGLOBALS !$ !; !$FERRSW !$BREAK CHT!$ (RP!*W T))

(SETQ !$ (SETQ !;
  "$ or ; are not used at command level, only to end formulas" ))

(SETFLUIDS FOARG!$)

(DDIPH !* !* !^)

(DDIPH !: !; !:!;)

(DDIPH !: != !:!=)

(DDIPH !: !$ !:!$)

(DDIPH !: !& !:!&)

(DDIPH !: !# !:!#)

(DE FOIN1 (PRMT!& SW!&)
 (SLET (A!& PARSPREFIX!*)
  (PROMPTER PRMT!& (PROMPT) (SETQ A!& (RSHEXP)))
  (COND (A!&
         (COND (PARSPREFIX!* (SETQ A!& (LIST PARSPREFIX!* A!&))))
         (COND (GLOBALPREFIX!* (SETQ A!& (LIST GLOBALPREFIX!* A!&)))) ))
  (SETQ A!& (COND
    (!$FERRSW (FSYNER A!& NIL))
    ((EQ CHT!$ '!.) (ISCOL (FOADD A!& FOARG!$)))
    ((OR (EQ CHT!$ '!$) (EQ CHT!$ '!:!$) (EQ CHT!$ ALT!*)) (SIMPI A!&))
    ((EQ CHT!$ '!:!;) (FOCONFIRM A!& T))
    ((AND (EQ CHT!$ !$EOF!$) (NULL A!&)) CHT!$)
    ((NOT (EQ CHT!$ '!;)) (FSYNER A!& T))
    ((NULL A!&) NIL)
    (SW!& (FOCONFIRM A!& NIL))
    (T (PRING (SIMPI A!&) FOARG!$)) ))
  (COND ((AND A!& (NOT (EQ A!& !$EOF!$))) (SETQ QWQ A!&)))
  A!&) )

(DE FOCONFIRM (X NODSIMPI)
 (COND ((AND X (NULL NODSIMPI)) (SETQ QWQ (SETQ X (SIMPI X)))))
 (COND
  ((AND !*INT (OR (STDINP) CFILFO))
   (SLET (A)
    (STDIN
     (EPRTO X FOARG!$)
     (COND
      ((SETQ A (FOIN1 "?" T)) A)
      ((NOT NODSIMPI) X)
      ((EQ CHT!$ '!;) (FOCONFIRM X NIL))
      (T (SIMPI X)) ) ) ) )
  (NODSIMPI (SIMPI X))
  (T X) ) )

(DE FSYNER (X ENDER)
 (SLET ((CFILFO T) (CHINPRO '!*))
  (COND
   (ENDER
    (WARNINGFT 120
     "The character '%w' is illegal as end character"
     CHT!$ ) ) )
  (WARNINGFT 122 "FOIN syntax error")
  (FOCONFIRM X T) ) )

(DE FOADD (X FOARG!$)
 (SLET ((OFOARG FOARG!$) PR1)
  (SETQ FOARG!$
   (COND ((NULL OFOARG) "Part1") (T (LIST 'TXT OFOARG "Part1"))) )
  (SETQ PR1 (FOINGE (FOCONFIRM X NIL)))
  (SETQ FOARG!$
   (COND ((NULL OFOARG) "Part2") (T (LIST 'TXT OFOARG "Part2"))) )
  (SETQ X (FOINP FOARG!$))
  (COND
   (PR1 (COND (X (SMPLUS2 PR1 X)) (T PR1)))
   (X X)
   (T 0) ) ) )

(DE FOLOOP () (SLET (FOARG!$)
  (UNTIL (EQ CHT!$ '!:!$) (FOIN1 "FO> " NIL))
  SUPPRESSANS!*))

(DE FOING () (FOINGE (FOIN1 "=" T)))

(DE FOINGE (X) (COND (X (SETQ QWQ X)) (T (ISCOL (EVAL (READ))))))

(DE ISCOL (X)
 (COND
   ((EQ CHT!$ '!;) (FOINGE (FOCONFIRM X NIL)))
   (T (SETQ QWQ X))))

(DE FOIN () (FOINP NIL))

(DE FOINP (FOARG!$) (PROGN
  (COND ((AND FOARG!$ (STDINP)) (EPRTO NIL FOARG!$)))
  (FOING) ))

% Should really use CONCATSTR when available. JEA
(DE FOINPC (FOARG!$)
 (FOINGE (FOIN1
   (MAKESTR (NCONC1
     (COND
      ((EQCAR FOARG!$ 'TXT)
       (FOREACH X IN (CDR FOARG!$)
        CONC (NCONC1 (EXPLODEC X) '! ) ) )
      (FOARG!$ (EXPLODEC FOARG!$)) )
     '!= ))
   T )) )

% (DE FOINPC (FOARG!$) (PROGN
%  (COND ((AND FOARG!$ (STDINP)) (EPRINX FOARG!$)))
%  (FOING) ))

(DE FOINPR (SW!&)
 (SLET ((A!& (FOIN)))
  (COND ((AND A!& SW!& (NOT (EQ A!& !$EOF!$))) (PRT A!&))) ) )

(DE FOINRR (FIL!& SW!&) (FOLDCASE T (FOINR FIL!& SW!&)))

(DE FOINR (FIL!& SW!&)
 (FILEIN FIL!&
  (SETQ CHT!$ NIL)
  (UNTIL
   (AND
    (OR (EQ CHT!$ !$EOF!$) (NOT (PAIRP (ERRSETT (FOINPR SW!&)))))
    (OR (PROGN (EQ CHT!$ !$EOF!$) (SETQ SW!& "Finished loading"))
        (PROGQ (NOT (SYESP "Continue loading? ")) (SETQ SW!& NIL)) ) )
   NIL) )
 (OR SW!& (ERRORFT 518 "Foin error return")) )

(DE ISETALIAS (X Y)
 (IREMALIAS X)
 (PUTXL Y 'REVALIAS X)
 (PUT X 'ALIAS Y) )

(DE IREMALIAS (X)
 (SLET ((A (REMPROP X 'ALIAS))) (COND (A (REMPROPXL A 'REVALIAS X)))) )



(DE RSHEXP ()
 (INITSTOKEN) (SETQ !$FERRSW NIL)
 (RCHENQ (RFOI) '!]) )

(DS RTOKQ (CH) (COND ((EQ CHT!$ CH) (STOKEN))))

(DE RCHENQ (X Y) (PROGN (RTOKQ Y) X))

(DE RFOIE (C!& P!&)
 (SLET ((A!& (RPLU)))
  (COND
   ((EQ CHT!$ C!&) (LIST P!& A!& (RPLU)))
   (T A!&) ) ) )

(DE RFOI () (RFOIE '!:!= 'SETEN))

(DE RPLU ()
 (SLET (FOSUM!& A!&)
  (STOKEN)
  (WHILE
   (PROGN
    (RTOKQ '!+)
    (SETQ A!& (COND ((EQ CHT!$ '!-) (RMIN)) (T (RPRO)))) )
   (XPUSH FOSUM!& A!&) )
  (NARYA FOSUM!& 'PLUS) ) )

(DE NARYA (A PREFIX)
 (COND
  ((NULL A) A)
  ((NULL (CDR A)) (CAR A))
  (T (CONS PREFIX (REVERSIP A))) ) )

(DE RMIN () (PROGN (STOKEN) (MKMIN (QFOER (RPRO)))))

(DE RPRO ()
 (SLET (FOPRO!& A!&)
  (WHILE
   (PROGN
    (RTOKQ '!*)
    (SETQ A!& (COND ((EQ CHT!$ '!/) (RINV)) (T (RPEXP)))) )
   (XPUSH FOPRO!& A!&))
  (NARYA FOPRO!& 'TIMES) ) )

(DE RINV () (PROGN (STOKEN) (MKSEXPT (QFOER (RPEXP)) -1)))

(DE RPEXP ()
 (SLET ((A!& (RPDIF)))
  (COND
   ((NOT (EQ CHT!$ '!^)) A!&)
   (T (SETQ A!& (QFOER A!&))
      (STOKEN)
      (MKSEXPT A!& (QFOER (RPDIF))) ) ) ) )

(DE RPDIF ()
 (SLET ((A!& (RPATM)) DN!& B!& FX!& RN!&)
  (WHILE (COND
    ((EQ CHT!$ '!&) (SETQ DN!& 1))
    ((EQ CHT!$ '!#) (SETQ DN!& 2) ) )
   (SETQ A!& (QFOER A!&))
   (SETQ FX!& NIL)
   (STOKEN)
   (COND ((FIXP CHT!$) (SETQ DN!& CHT!$) (STOKEN)))
   (COND
    ((NOT (EQ CHT!$ '!()) (SETQ RN!& 1) (SETQ B!& (RPATM))) % !)
    ((STOKEN)
       (SETQ B!& (RPATM))
       (RTOKQ '!))                      % !(
       (COND
        ((FIXP B!&) (SETQ RN!& B!&) (SETQ B!& (RPATM)))
        (T (SETQ RN!& 1) (SETQ !$FERRSW T)) ) ) )
   (SETQ B!& (QFOER B!&))
   (COND ((NOT (ATOM B!&)) (SETQ !$FERRSW T)))
   (REPEATS RN!& (XPUSH FX!& B!&))
   (SETQ A!& (CONSA (QFOER (XVTGTN DN!&)) A!& FX!&)) )
  A!&) )

(DE RPATM () (IRPATM NIL))

(DE IRPATM (SW!&)
 (SLET ((A!& CHT!$) B!&)
  (COND
   ((OR (NULL A!&) (NOT (IDP A!&))) (STOKEN) A!&)
   ((SETQ B!& (ATSOC A!& TENALIAS!*)) (SETQ CHT!$ (CDR B!&)) (RPATM))
   ((SETQ B!& (GET A!& 'ALIAS)) (SETQ CHT!$ B!&) (RPATM))
   ((SETQ B!& (GET A!& 'PARSF)) (FUNCALL B!& A!&))
   (!$BREAK NIL)
   ((GET A!& 'EFUN) (RTRIG A!&))
   ((OR SW!& (GET A!& 'DFUN)) (RTRIM A!&))
   (T (STOKEN) A!&) ) ) )

(DC E PARSF (DUMMY) (STOKEN) (LIST 'EXP 1))

(DC I PARSF (DUMMY) (STOKEN) IMNT!*)

(DC !( PARSF (DUMMY) (RCHENQ (RFOI) '!)))

(DC ![ PARSF (DUMMY) (RCHENQ (RFOI) '!]))

(DC !: PARSF (DUMMY)
 (STOKEN)
 (FEVAL (COND
   (!$BREAK (PROG1 (FDORE1) (STOKEN)))
   (T (IRPATM (FNP CHT!$))) )) )

(DS IRTRIG (FN) (LIST FN (XRPATM)))

(DE RTRIG (FN) (STOKEN) (IRTRIG FN))

(DE XRPATM () (QFOER (RPATM)))

(DE RTRIM (FN) (SLET (A!&) (COND
   ((EQ (STOKEN) '!() % !)
    (UNTIL (NOT (EQ CHT!$ '!,)) (XPUSH A!& (QFOER (RFOI))))
    (RTOKQ '!))                       % !(

    (CONS FN (REVERSIP A!&)) )
   ((SETQ A!& (RPATM)) (LIST FN A!&))
   (T FN) )))

(DE RFUI (A!&) (SLET (B!& VR!&)
  (STOKEN)
  (SETQ A!& (RFOI))
  (WHILE (EQ CHT!$ '!,)
   (STOKEN)
   (SETQ B!& (RPATM))
   (COND
    ((NOT (FIXP B!&)) (XPUSH VR!& B!&))
    ((XLESSP B!& 1) (SETQ !$FERRSW T) (XPUSH VR!& B!&))
    ((NULL VR!&) (SETQ VR!& (LIST (QFOER VR!&))))
    (T (REPEATS (XSUB1 B!&) (XPUSH VR!& (CAR VR!&)))) ) )
  (COND ((NULL VR!&) (SETQ VR!& (LIST (QFOER VR!&)))))
  (RTOKQ '!))                           % !(
  (CONSA (OR DFDIF!* CRDIF!*) A!& VR!&) ))

(DC RESET PARSF (DUMMY) (RESET))

(DC QUIT PARSF (DUMMY) (QUIT))

(DC BYE PARSF (DUMMY) (BYE))

(DEFLIST '((DF RFUI) (HELP PRSHELP) (!? PRSHELP)) 'PARSF)

(DC SQRT PARSF (DUMMY) (STOKEN) (MKSEXPT (XRPATM) HALF!*))

(DC DEPEND PARSF (FN) (SLET (AR)
  (UNTIL (NOT (EQ CHT!$ '!,)) (XPUSH AR (QFOER (RFOI))))
  (CONSA FN (OR DFDIF!* CRDIF!*) (REVERSIP AR)) ))

%(DE FOINLIST (FN) (SLET (AR)   % Nowhere used. JEA.
%  (UNTIL (NOT (EQ CHT!$ '!,)) (XPUSH AR (QFOER (RFOI))))
%  (CONS FN (REVERSIP AR)) ))

(DC ARRAY PARSF (FN) (SLET (AR)
  (UNTIL (NOT (EQ CHT!$ '!,))
   (STOKEN)
   (XPUSH AR (QFOER (IRPATM T)))
   (COND
    ((NOT (TENP (CAAR AR)))
     (WARNINGFT 124 "%r has not been declared tensor" (CAAR AR)) )) )
  (CONS FN (REVERSIP AR)) ))

(DC LET PARSF (FN) (SLET (AR)   % JEA
  (UNTIL (NOT (EQ CHT!$ '!,)) (XPUSH AR (QFOER (RFOIE '!= 'EQUAL))))%:LH
  (CONS FN (REVERSIP AR)) ))

(DE PRSHELP (DUMMY)
 (QHELP
  (OR
   HELPFN!*
   "You are in FOIN mode, formula input expected" ) )
 (PROMPT)
 (STOKEN)
 (RPATM) )

(DE QFOER (X) (COND (X X) (T (SETQ !$FERRSW '!?))))

(DE FEVAL (X!&)
 (COND ((SETQ X!& (VERRS X!&)) (COPYL X!&)) (T (SETQ !$FERRSW '!:!?))) )



(DE FDORED ()
 (STOKEN)
 (COND
  (!$BREAK (FDORE1))
  (T CHT!$) ) )

(DE FDORE1 () (COND
  ((EQ CHT!$ '!') (MKQUOTE (FDORED)))
  ((EQ CHT!$ '!() (FDORELIS (LIST (FDORED)))) % !)
  ((EQ CHT!$ '!+) (FDORED))
  ((EQ CHT!$ '!-) (MINUS (FDORED)))
  (T (SETQ !$FERRSW T) (CONS '!?!? CHT!$)) ))

(DE FDORELIS (X)
 (STOKEN)
 (COND
  ((NOT !$BREAK) (FDORELIS (CONS CHT!$ X)))
  ((EQ CHT!$ '!)) (REVERSIP X)) % !(
  ((EQ CHT!$ '!.)
   (SETQ X (REVERSIPX X (FDORED)))
   (STOKEN)
   (COND
    ((EQ CHT!$ '!)) X)                  % !(
    (T (SETQ !$FERRSW T) (LIST '!?!) X CHT!$)) ) ) % !(
  (T (FDORELIS (CONS (FDORE1) X))) ) )

%### FOIN.SL end
