%### IXTYPE.SL

(DMACRO INDEXTYPE (CRTYPE!* !&REST L)
 (SLET ((CRDIF!* CRTYPE!*) (A (GET CRTYPE!* 'TRANS!-OF)))
  (COND 
   (A (SETQ CRDIF!* (CDR A)))
   (T (XSETIXTYP CRTYPE!*)) )
  (FOREACH X IN L DO (COND ((PAIRP X) (EVAL X)))) ) )

(DS INDEXFLAG (!&REST L) (IINDEXFLAG (LIST . L)))

(DE IINDEXFLAG (L) (FOREACH X IN L DO (FLAG1 CRTYPE!* X)))

(DE DIMENSION (N) (FOREACH X IN (GET CRTYPE!* 'SDIM) DO (PUT X 'DIM N)))

(DE LOWINDEX (N) (COND
  ((OR (NOT (FIXP N)) (AZEROP N)) (REMPROP CRTYPE!* 'LOWX))
  (T (PUT CRTYPE!* 'LOWX N)) ))

(DS VECTORS (!&REST L) (IVECTORS (LIST . L)))


%### IXTYPE.SL End
