%### SCOLL.SL

(SETGLOBALS ((BTRM!$ (LIST NIL))) ((ATRM!$ (LIST NIL))))

(SETFLUIDS CTINM!$ CTIPL!$)

(DE SMPLUS2 (X Y) (COND
  ((AZEROP X) Y)
  ((AZEROP Y) X)
  ((AND (SNUMP X) (SNUMP Y)) (SPLUS X Y))
  (T (PLUSEND (COND
       ((EQCAR Y 'PLUS) (ICOLLPLUS Y (NCONS X)))
       ((EQCAR X 'PLUS) (ICOLLPLUS X (NCONS Y)))
       (T (ICOLLPLUS (LIST 'PLUS Y) (NCONS X))) ))) ))

(DE SMPLUSL (SXP) (SLET ((A (CDR SXP)) B C)
  (WHILE (SETQ C A)
   (UNPUSH A) (COND ((NOT (AZEROP (CAR C))) (SETQ B (RPLACD C B)))) )
  (COND
   ((NULL B) 0)
   ((NULL (SETQ A (CDR B))) (CAR B))
   (T (PLUSEND (ICOLLPLUS
        (COND
         ((EQCAR (CAR B) 'PLUS) (CAR B))
         (T (RPLACD SXP (RPLACD B NIL))) )
        A))) ) ))

(DE ICOLLPLUS (SXP A)
 (SLET ((B SXP) C D X)
  (WHILE (SETQ D A) (UNPUSH A)
   (COND
    ((AZEROP (SETQ X (CAR D))) T)
    ((EQCAR X 'PLUS)
     (SETQ B SXP)
     (SETQ C (CDR X))
     (WHILE (SETQ X C) (UNPUSH C) (SETQ B (PLORDN X B))) )
    (T (PLORDN D SXP) ) ))
  SXP))

(DE SMADDTERM (SXP)
 (COND
  ((AZEROP SXP) NIL)
  ((EQCAR SXP 'PLUS)
   (COND
    (COLL!*
     (SLET
      ((B COLL!*) (C (CDR SXP)))
      (WHILE (SETQ SXP C) (UNPUSH C) (SETQ B (PLORDN SXP B))) ) )
    (T (SETQ COLL!* SXP)) ))
  (COLL!* (PLORDN (NCONS SXP) COLL!*))
  (T (SETQ COLL!* (LIST 'PLUS SXP))) ))

(DE PLUSEND (SXP)
 (COND
  ((NOT (AND SXP (CDR SXP))) 0)
  ((CDDR SXP) SXP)
  (T (CADR SXP)) ) )

(DE PLORDN (MR PR) 
 (SLET ((C (CAR MR)) (NX (CDR PR)) AP A B)
  (SETQ AP (COND 
    ((SNUMP C) (SETQ A 3) NIL)
    ((NOT (EQCAR C 'TIMES)) (SETQ A 0) (RPLACA ATRM!$ C))
    ((SNUMP (CADR C)) (SETQ A 2) (CDDR C))
    (T (SETQ A 1) (CDR C)) ))
  (WHILE
   (AND NX (EQ 'GOON (SETQ C (BIGGTERM AP (COND
        ((SNUMP (SETQ C (CAR NX))) (SETQ B 3) NIL)
        ((NOT (EQCAR C 'TIMES)) (SETQ B 0) (RPLACA BTRM!$ C))
        ((SNUMP (CADR C)) (SETQ B 2) (CDDR C))
        (T (SETQ B 1) (CDR C)) )))))
   (SETQ PR NX) (UNPUSH NX) )
  (RPLACA ATRM!$ NIL)
  (RPLACA BTRM!$ NIL)
  (COND
   ((OR (NULL NX) C) (RPLACD PR MR) (RPLACD MR NX))
   ((PROGN (SETQ C (CAR NX))
     (SETQ C (XCASE (MAX B A) NIL
       (LIST 'TIMES 2 C)
       (RPLACD C (CONS 2 (CDR C)))
       (COND
        ((AZEROP (SETQ MR (COND
                  ((IEQN B A) (SPLUS (CADR C) (CADAR MR)))
                  (T (COND ((ILESSP B A) (SETQ C (CAR MR))))
                     (SADD1 (CADR C)) ) )))
         NIL)
        ((NOT (AONEP MR)) (RPLACA (CDR C) MR) C)
        ((CDDR (RPLACD C (CDDR C))) C)
        (T (CADR C)) )
       (COND ((NOT (AZEROP (SETQ MR (SPLUS C (CAR MR))))) MR)) )) )
    (RPLACA NX C) )
   (T (RPLACD PR (CDR NX))) ) ) )

(DE SMTIMES2 (X Y)
 (SLET (!*REORDSW (A (COND ((PAIRP X) (CAR X))))
        (B (COND ((PAIRP Y) (CAR Y)))) )
  (COND
   ((SNUMP X) (SNUTIM X Y))
   ((SNUMP Y) (SNUTIM Y X))
   ((EQ B 'PLUS) (COND
     ((EQ A 'PLUS) (ICOLLTIMES 1 1 NIL Y (NCONS X)))
     (T (ICOLLTIMES 1 X NIL Y NIL)) ))
   ((EQ A 'PLUS) (ICOLLTIMES 1 Y NIL X NIL))
   ((EQ B 'TIMES) (ICOLLTIMES 1 Y (NCONS X) NIL NIL))
   ((EQ A 'TIMES) (ICOLLTIMES 1 X (NCONS Y) NIL NIL))
   (T (ICOLLTIMES 1 (LIST 'TIMES Y) (NCONS X) NIL NIL)) ) ) )

(DE ISMTIMES2 (X Y)
 (SETQ !*REORDSW NIL)
 (COND
  ((SNUMP X) (SNUTIM X Y))
  ((SNUMP Y) (SNUTIM Y X))
  ((EQCAR Y 'TIMES) (ICOLLTIMES 1 Y (NCONS X) NIL NIL))
  ((EQCAR X 'TIMES) (ICOLLTIMES 1 X (NCONS Y) NIL NIL))
  (T (ICOLLTIMES 1 (LIST 'TIMES Y) (NCONS X) NIL NIL)) ))

(DE SMTIMESL (SXP)
 (SLET (!*REORDSW PL (N 1) TI A (B (CDR SXP)) X)
  (WHILE (SETQ A B)
   (UNPUSH B)
   (COND
    ((SNUMP (SETQ X (CAR A))) (SETQ N (STIMES X N)))
    ((EQCAR X 'PLUS) (SETQ PL (RPLACD A PL)))
    (T (SETQ TI (RPLACD A TI))) ) )
  (COND
   ((NULL (SETQ A TI)) (SETQ SXP N))
   ((NULL (UNPUSH TI)) (SETQ SXP (SNUTIM N (CAR A))))
   ((EQCAR (CAR A) 'TIMES) (SETQ SXP (CAR A)))
   (T (RPLACD SXP (RPLACD A NIL))) )
  (COND (PL (SETQ B (CAR PL)) (UNPUSH PL)))
  (ICOLLTIMES N SXP TI B PL) ) )

(DE ICOLLTIMES (CTINM!$ SXP TI SX PL) (PROG (CTIPL!$ B C D L)
  (COND (TI (COND ((SNUMP (CADR SXP))
                   (SETQ CTINM!$ (STIMES (CADR SXP) CTINM!$))
                   (RPLACD SXP (CDDR SXP)) ))
            (WHILE (SETQ D TI) (UNPUSH TI)
             (COND
              ((SNUMP (SETQ L (CAR D)))
               (SETQ CTINM!$ (STIMES L CTINM!$)) )
              ((EQCAR L 'TIMES)
               (SETQ B SXP)

               (SETQ C (CDR L))
               (COND
                ((SNUMP (CAR C))
                 (SETQ CTINM!$ (STIMES (CAR C) CTINM!$))
                 (UNPUSH C) ) )
               (WHILE (SETQ L C) (UNPUSH C) (SETQ B (TIORDN L B))) )
              (T (TIORDN D SXP) ) ))
            (COND
             ((NULL (CDR SXP)) (SETQ SXP CTINM!$))
             ((NOT (AONEP CTINM!$))
              (RPLACD SXP (CONS CTINM!$ (CDR SXP))) )
             ((NULL (CDDR SXP)) (SETQ SXP (CADR SXP))) )
            (COND ((AND (SETQ PL (NCONC PL CTIPL!$)) (NULL SX))
                   (SETQ SX (CAR PL)) (UNPUSH PL) )) ))
  (COND
   ((NULL SX) (RETURN SXP))
   (NOEXPAND
    (XPUSH PL SX)
    (COND
     ((NOT (SNUMP SXP)) (XPUSH PL SX))
     ((NOT (AONEP SXP)) (RPLACA PL (SNUTIM SXP SX))) )
    (RETURN (COND
      ((CDR PL) (CONS 'FACTOR PL))
      (T (CAR PL)) )) ) )
  (FOREACH SUM IN PL DO
   (SETQ TI NIL)
   (SETQ B (CDR SX))
   (SETQ L NIL)
   (SETQ C (CADR SUM))
   (RPLACD SX (FOREACH X IN B CONC
    (COND
     ((REORDNP (SETQ X (ISMTIMES2 (COPYL C) (COPYL X))))
      (XPUSH TI X)
      NIL )
     ((OR L TI) (LIST X))
     (T (SETQ L (LIST X))) )))
   (SETQ C SX)
   (FOREACH X IN (CDDR SUM) DO
    (SETQ C (SETQ D (OR L C)))
    (SETQ L NIL)
    (FOREACH Y IN B DO
     (COND
      ((REORDNP (SETQ Y (ISMTIMES2 (COPYL X) (COPYL Y)))) (XPUSH TI Y))
      (T (SETQ D (PLORDN (NCONS Y) D))) )
     (COND ((NULL L) (SETQ L D))) ) )
   (COND (TI (ICOLLPLUS SX TI))) )
  (RETURN (COND
    ((NULL (CDR SX)) 0)
    ((AONEP SXP) (PLUSEND SX))
    ((SNUMP SXP) (SNUTIM SXP (PLUSEND SX)))
    (T (SETQ TI NIL)
       (SETQ PL SX)
       (WHILE (SETQ C (CDR PL))
        (COND
         ((REORDNP (CAR (RPLACA C (ISMTIMES2 (COPYL SXP) (CAR C)))))
          (RPLACD PL (CDDR PL)) (SETQ TI (RPLACD C TI)) )
         (T (SETQ PL C)) ) )
       (PLUSEND (COND
        (TI (ICOLLPLUS SX TI))
        (T SX) )) ) )) ))

(DE REORDNP (X) (OR !*REORDSW (EQCAR X 'PLUS)))

(DE TIORDN (MR PR) 
 (SLET ((C (CAR MR)) (NX (CDR PR)) AP A B)
  (SETQ AP (COND 
    ((EQCAR C 'EXPT) (SETQ A 1) (CADR C))
    ((EQCAR C 'EXP) (SETQ A 2) '(EXP))
    (T (SETQ A 0) C) ) )
  (WHILE
   (AND NX (EQ 'GOON (SETQ C (BIGGKERN AP (COND
        ((EQCAR (SETQ C (CAR NX)) 'EXPT) (SETQ B 1) (CADR C))
        ((EQCAR C 'EXP) (SETQ B 2) '(EXP))
        (T (SETQ B 0) C) )))))
   (SETQ PR NX) (UNPUSH NX) )
  (COND
   ((OR (NULL NX) C) (RPLACD PR MR) (RPLACD MR NX))
   ((PROGN (SETQ C (CAR NX))
     (NOT (SNUMP (SETQ C (XCASE (MAX B A) NIL
         (COND ((EQ C IMNT!*) (SETQ !*REORDSW T) -1) (T (MKSEXPT C 2)))
         (PROGN (SETQ B (COND
            ((IEQN B A) (CADDAR MR))
            ((ILESSP B A) (SETQ C (CAR MR)) 1)
            (T 1) ))
          (PCOLLEX (CADR C) (SMPLUS2 (CADDR C) B) C) )
         (COND
          ((AZEROP (SETQ MR (SMPLUS2 (CADR C) (CADAR MR)))) 1)
          (T (RPLACA (CDR C) MR) C) ) )))) )
    (RPLACA NX C) )
   (T (COND ((NOT (AONEP C)) (SETQ CTINM!$ (STIMES C CTINM!$))))
      (RPLACD PR (CDR NX)) ) ) ) )

(DE GETNPL (X)
  (COND
    ((NULL (CDR X)) NIL)        % Bugfix. Bug detected by MAHM. JEA.
    ((SNUMP (CADR X)) X)
    (T (GETNPL (CDR X))) ) )

(DE PCOLLEX (BAS EX C) (PROG (A PSW)
  (RPLACA (CDDR C) EX)
  (COND
   ((AZEROP EX) (RETURN 1))
   ((AONEP EX) (RETURN (COND
      ((EQCAR BAS 'PLUS) (XPUSH CTIPL!$ BAS) 1)
      ((SNUMP BAS) (SETQ !*REORDSW T) BAS)
      (T BAS) )))
   ((AND (EQCAR EX 'PLUS) (SETQ PSW (GETNPL EX))) (SETQ EX (CADR PSW)))
   ((NOT (SNUMP EX)) (RETURN C)) )
  (COND
   ((EQ BAS IMNT!*) (COND
     ((SLESSP EX 2) (RETURN C))
     ((PROGN (SETQ CTINM!$ (SMINUS CTINM!$))
       (AND (AONEP (SETQ EX (SDIFFERENCE EX 2))) (NOT PSW)) )
      (SETQ !*REORDSW T) (RETURN IMNT!*) ) ))
   ((OR
     (NOT (OR (EQCAR BAS 'PLUS) (SNUMP BAS)))
     (AZEROP (SETQ A (SFIX EX))) )
    (RETURN C) )
   ((PROGN (SETQ EX (SFRACTION EX)) (EQCAR BAS 'PLUS)) (COND
     ((OR (MINUSP A) (GREATERP A EXPANDLIM!*)) (RETURN C))
     (T (REPEATS A (XPUSH CTIPL!$ (COPYL BAS)))) ))
   ((GREATERP (ABS A) POWER!*) (RETURN C))
   (T (SETQ CTINM!$ (STIMES (SEXPT BAS A) CTINM!$))) )
  (SETQ !*REORDSW T)
  (RETURN
   (COND
    ((NOT (AZEROP EX))
     (RPLACA (COND (PSW (CDR PSW)) (T (CDDR C))) EX)
     C )
    ((NOT PSW) 1)
    (T (RPLACD PSW (CDDR PSW))
       (COND
        ((NULL (CDDAR (SETQ PSW (CDDR C))))
         (RPLACA PSW (CADAR PSW)) ) )
       C) )) ))

%### SCOLL.SL end
