;;;### MKCSL.SL =======================================================
;;;
;;;       MKCSL.SL
;;;       --------
;;;
;;;       Copyright (c) 1991 by Jan E. Aman, Institute of Theoretical
;;;       Physics, University of Stockholm, Vanadisvagen 9,
;;;       S-113 46  Stockholm, Sweden.
;;;
;;;       This file contains the commands executed in Lucid Common
;;;       Lisp to build an interpreted Sheep Lisp.
;;;
;;;====================================================================

(LOAD "slcpload")

(setf *common-lisp-readtable* *readtable*)

(setf *readtable* *standard-lisp-readtable*)

(in-package 'standard-lisp)

% To get faster code (at the expence of longer compilation time).
(PROCLAIM '(OPTIMIZE (COMPILATION!-SPEED 0)))
% Turn on messages from compiler.
(COMPILER!-OPTIONS :MESSAGES T)

(SETQ !*COMP T)

(LOAD "ldint.sl")

(SETQ !*MODULCOMP NIL)          % Makes MODULOAD just become LOAD.

(SETQ DATE!* (DATETIME))

%(SAVERUN ISLISP)

%### MKCSL.SL end
