%### LDINT.SL =======================================================
%
%       LDINT.SL
%       --------
%
%       Copyright (c) 1993 by Jan E. Aman, Institute of Theoretical
%       Physics, University of Stockholm, Vanadisvagen 9,
%       S-113 46  Stockholm, Sweden.
%
%       This file loads the files into Codemist Standard Lisp (CSL)
%       to build an interpreted Sheep Lisp.
%
%====================================================================

(RDF "inclde.sl")

(INCLUDE "exfn1.sl")

% Used for testing which system is running.
(SETQ !*RSHEEP NIL)

(INCLUDE "systyp.sl")
(INCLUDE "exint.sl")
(INCLUDE "exfn2.sl")
(INCLUDE "printf.sl")
(INCLUDE "load.sl")

% List of extensions searched for:
(SETQ MEXTLIS!* '(PSEUDO!-FILE SL))
(DPUT SLLSPEXT SUBDRS SL)       % Extension for Sheep Lisp sources.
(DPUT SHPSRCEXT SUBDRS SHP)     % Source extension for Sheep.

(IFP
 (NOT (AND (EQ 'ATARI (SYSTYPE 'MACHINE)) (LESSP (SYSTYPE 'MEMORY) 2)))
 (INCLUDE "../newnam.sl") )     %:Atari skip luxury

(PROGN (REMD 'IINCLUDE) NIL)

(SETPROMPTER "SL> ")

% Set up search list. MSEARCHLIS!* is reset in SSLISP.INI. JEA.
(SETQ MSEARCHLIS!*
 '(NIL HERELIST ".." "../.." "../../shpsrc/csl" "../../shpsrc"))

(SETQ TOPDIR!* "/users/sheep/059")      % Bad fix

%### LDINT.SL end
