%### OLDCOD.SL

% Formerly called oldcode.sl.

% This is old code no longer in use for modern versions of Cambridge
% University Lisp. The reason for keeping this in a file is that some
% of this code may be useful together with older versions of Culisp,
% in fact some of this code stored here was reinstalled into the
% running code in oder to cope with the old Culisp for Atari ST. JEA.

%(FLUID '(
%         NORMALPROMPT!* NORMALVPROMPT!* !*EOF!-STATUS!*))
%        CALLINITSW!* 

%(IFP (NOT (GETD 'I!$OPEN)) (SETQ I!$OPEN OPEN))

% Use of STRTOID ensures that OPEN will not be given string (Illegal).
%(DE OPEN (X Y) (I!$OPEN (COND ((STRINGP X) (STRTOID X)) (T X)) Y))

% STRTOID defined this way in module inclde.sl.
% Defined here again in order to be compiled.
%(DE STRTOID (STRING) (CLEARBUFF) (PACK STRING NIL) (MKATOM))

% Emergency fix to get around pack-bug in Culisp.
% (COND ((NOT (GETD 'I!$PACK))
%        (PUTD 'I!$PACK (CAR (GETD 'PACK)) (CDR (GETD 'PACK))) ))

% (DE PACK (STR) (I!$PACK STR T))

%(DMACRO ERRSETT (!&REST U) (LIST 'ERRSET (I!$PROGN U) '!*BACKTRACE))

% (DF INCLUDE (U)

%  (PROGN
%   (CLEARBUFF)
%   (PACK U)
%   (SETQ U (MKATOM U))
%   (TERPRI) (PRINC "INCLUDEing file: ") (PRINTC U) (TERPRI)
%   (RDF U NIL)
%   (TERPRI) (PRINC U) (PRINTC " done include") (TERPRI)
%   "Finished loading") )

(SETFLUIDS QTRDBG!*)
% QTRPRI does a TERPRI if not at beginning of line. Debugging
(DE QTRPRI () (SLET ((POS (POSN)))
  (COND (QTRDBG!* (PRIN2 "<QTRPRI at posn ") (PRIN2 POS) (PRIN2 ">")))
  (COND ((NOT (IZEROP POS)) (TERPRI))) ))

% Suppress compiler timings or messages.
% NIL instead of T is bugfix to Lisp 0.96/0.96/4432636 of 2 Feb 1986.
% (IFP (BOUNDP '!*NOTIME) (SETQ !*NOTIME NIL) (SETQ !*PWRDS NIL))

% (NOCOMP) % Fixing the ^Ci problem after compilation in Culisp 0.93.
% Testing.

% Testing. Works normally ok, but seems to interact
% with bugs in culisp. Works reasonable in 1feb85 version but gives
% horrible backtraces.
(DE SLISPTOP ()
 (QTRPRI)
 (TERPRI)
 (PROMPT)
 (CLEAR!-EOF!-STATUS)  % Reset reader if it just had an eof
 (SLET ((S!- (SLET ((!*ECHO !*TTYECHO)) (ERRSETT (READ)))))
  (COND
   ((AND (PAIRP S!-) (NOT (EQ (SETQ S!- (CAR S!-)) !$EOF!$)))
    (DFEVAL S!- T) )
   ((NOT (EQ S!- !$EOF!$)))
   (!*INT (TERPRI) (BELL))
   (T (QUIT)) ) ) )

% Fixing the ^Ci problem after compilation in Culisp 0.93.
% (RESTORECOMP)

% (DE SLISPTOP NIL (SUPERVISOR)) % Emergency version. Works ok. JEA

% (SETQ TOPLEVEL!* SUPERVISOR)  % Use SUPERVISOR, not ISLISPTOP.

% CATCH can still not (0.96) be compiled, but NEWLISPTOP can be
%  compiled by making the CATCH here not compiled.
(DE NEWLISPTOP () (PROG (!*ERRMSG STK!&VL)
% (RESTOREPROMPT)
 (UNTIL NIL
  (SETQ STK!&VL (CAPTURESFSTKS))
  (COND
   ((OR (NULL !*BACKTRACE) (AZEROP !*BACKTRACE))
    (SETQ !*BACKTRACE 1) ) )
%  (ERRORSET (CATCH NIL (XLISPTOP)) (SETQ !*ERRMSG !*BACKTRACE))
  (ERRORSET (LIST 'CATCH NIL '(XSLISPTOP)) % Don't compile CATCH
   (SETQ !*ERRMSG !*BACKTRACE) )
  (PRINCL "Returning to top level")
  (TERPRI)
  (UNBINDSFSTKS NIL STK!&VL) ) ))

% (DE SLISPTOP ()       % Emergency version. Works ok also compiled. JEA
%  (RESTOREPROMPT)
%  (SUPERVISOR) )

% The following is needed when not Orion Culisp version
% of 13 dec 1984 and later. Altered definition of PACK April 1985. JEA
(DE ULCASE (X SW)
 (CLEARBUFF)
 (FOREACH Y IN (EXPLODECN X) DO
  (PACKBYTE (COND
    ((OR (ILESSP Y 65) (IGREATERP Y 122)) Y)
    ((ILESSP Y 91) (COND (SW Y) (T (IPLUS Y 32))))
    ((OR (NOT SW) (ILESSP Y 97)) Y)
    (T (IDIFFERENCE Y 32)) )) )
  (MKATOM) )

 (DE CSLSPINI ()
  (PROG (ICOM!$ !*GOTOP !*STOPCMPARS)
   (RDS NIL)
   (WRS NIL)
   (SET!-TOP!-LEVEL SLISPTOP!*)
   (IFP !!COMMANDLINE (PROGN
     (INITCOMMANDLINE)
 %   (COND ((AND (INITCOMMANDLINE)
      (EQ (CAR (SETQ ICOM!$ (NEXTONCOMLIN))) '!-X)
  %     (MEMQ '!-X ARGV!*)
  %     ) (GO TOP) ))
  %   (SETQ ICOM!$ (NEXTONCOMLIN))      % Added
  %   (ERRSETT (WHILE ICOM!$
  %     (COND ((NOT (TRYINICHSWITCH (SETQ ICOM!$ (CAR ICOM!$))))
  %            (CALINISWITCH ICOM!$) )) ))
%     (WHILE (AND (NOT !*STOPCMPARS) (SETQ ICOM!$ (NEXTONCOMLIN)))
  %     (TRYINICHSWITCH (SETQ ICOM!$ (CAR ICOM!$)))
  %     (SETQ ICOM!$ (NEXTONCOMLIN))
%      (DOINICHCMD (CAR ICOM!$)) )
%     (SETQ CALLINITSW!* (CONS 'PROGN (REVERSIP CALLINITSW!*)))
%     (COND (!*GOTOP (RETURN NIL))) ) )
%   (COND (INITS!* (FOREACH ICOM!$X IN INITS!* DO (EVAL ICOM!$X))
%                  (SETQ INITS!* NIL) ))
%   (INITSEARCHLIS)
%   (LOADP SYSINITFILE!* (SYSINILIS) '(NIL) T NIL)
%   (QTRPRI)
%   (COND ((LOADP INITFILE!* MSEARCHLIS!* '(NIL) T NIL) (TERPRI)))
%   (IFP !!COMMANDLINE (EVAL CALLINITSW!*))
%   (COND (INITMESSAGE!* (PRIN2 INITMESSAGE!*)))
%   (COND (DATE!* (PRIN2 "(") (PRIN2 DATE!*) (PRIN2 ")")))
%   (QTRPRI) ) )

% TOPDIR!* is (PREFIXOF (ARGV 0)) in Franz.
(DS SYSINILIS () (NCONS TOPDIR!*))

% If not compiled, references to SW!& in body will cause problems. JEA
% (DFEXPR ERRSET (BODY SW!&) (ERRORSET BODY (EVAL SW!&)))

% (DFEXPR UNWINDPROTECT (UWP!&PRO !&REST UWP!&L)
%  (SETQ UWP!&PRO (ERRORSET UWP!&PRO !*ERRMSG))
%  (I!$!*PROGN UWP!&L)
%  (COND
%   ((PAIRP UWP!&PRO) (CAR UWP!&PRO))
%   (T (ERROR UWP!&PRO EMSG!*)) ) )

%### OLDCOD.SL end
