%### SYSTYP.SL ======================================================
%
%       SYSTYP.SL
%       --------
%
%       Copyright Inge Frick, Institute of Theoretical
%       Physics, Vanadisvagen 9, S-113 46 Stockholm, Sweden.
%
%
%       This file contains the SYSTYPE commands that tells which system,
%       site etc. that you have. Edit it appropriately for your site.
%
%====================================================================

(IFP (status feature unix)              % Check if Franz Lisp system
 (PROGN                                 % is for Unix or VMS.
  (SETSYSTYPE 'SITE 'QMC)               % This is for a typical Unix
  (SETSYSTYPE 'MACHINE 'VAX)            % installation (Queen Mary
  (SETSYSTYPE 'MACHINEVERS 750)         % College, London).    JEA
  (SETSYSTYPE 'OS 'UNIX)
  (SETSYSTYPE 'OSTYPE 'BSD)
  (SETSYSTYPE 'OSVERS 4.2)
  (SETSYSTYPE 'LISPSYSTEM 'FRANZ)       % LISPSYSTEM and LISPVERS
  (SETSYSTYPE 'LISPVERS 38.79) )        % added. JEA
 (PROGN
  (SETSYSTYPE 'SITE 'VANADIS)           % This is for a VMS installation
  (SETSYSTYPE 'MACHINE 'VAX)            % (Physics, University of
  (SETSYSTYPE 'MACHINEVERS '(780 750))  % Stockholm) running on both 780
  (SETSYSTYPE 'OS 'VMS)                 % and 750.
  (SETSYSTYPE 'OSVERS 4.3)              % JEA
  (SETSYSTYPE 'LISPSYSTEM 'FRANZ)
  (SETSYSTYPE 'LISPVERS 38.79) ))       % JEA

%### SYSTYP.SL end
