%### MKSL.SL ========================================================
%
%       MKSL.SL
%       -------
%
%       Copyright (c) 1988 - 2011 by Jan E. Aman and Inge Frick,
%       Department of Physics, Stockholm University,
%       SE-106 91  Stockholm, Sweden.
%
%       This file contains the commands executed in Portable Standard
%       Lisp (PSL) to build a compiled Sheep Lisp.
%
%====================================================================

(LOAD COMPILER)

(SETQ !*COMP NIL)

(COND ((NOT (GETD 'INCLUDE)) (DSKIN "ldint.sl")))

(COND ((NOT (GETD '!$ERRFORM)) (INCLUDE "excom.sl")))

(SETQ !*COMP T)

(INCLUDE "exfn1.sl")
%(FASLOUT "exslmc") (DSKIN "excom.sl") (FASLEND)
(INCLUDE "excom.sl")
(INCLUDE "exint.sl")
(INCLUDE "exfn2.sl")
(INCLUDE "printf.sl")
(INCLUDE "load.sl")
%(INCLUDE "../newnam.sl")

(SETQ !*COMP NIL)

(SETQ DATE!* (DATETIME))

(SAVERUN PSLISP)

%### MKSL.SL end
