%*** STENEW.MAN ***  Help on new features in STENSOR ************************
*                                                                           *
*          Addendum to the Nov 1986 STENSOR manual (ed. 6)                  *
*                                                                           *
*    Additional documentation that will be merged with the STENSOR manual   *
*        Valid only for VAX versions from 2.267, not yet on DEC             *
*                             Dec 1986                                      *
*                                                                           *
*                          Lars  Hornfeldt                                  *
*                                                                           *
*****************************************************************************
(REMTEN t1 t2 t3..) -Remove these as tensors in Sheep sense, ie strip from them
any array or associated properties (BULF TENARY TTYPE DIML YCOPY), plus those
in the list TENPROPERTIES.
This makes t1 t2.. unknown as far as component calculations are conserned.
If your STENSOR was built on some application package (eg CLASSI), it will
already at startup contain tensors, that might interfer (DEP-PREQ-wise)
with a new family of tensors you want to PDEF+TCOMP. Then first remove
those undesired, maybe by (REMTEN ALL).
While above removes SHEEP-properties, next two removes STENSOR properties:

(REMSYM t1 t2..) Remove symmetries of t1 t2..

(REMDEF t1 t2..) Remove DEFinitions of t1,t2.. Removes only the DEF-property.
There might be a backup ODEF retrieved by XDEF. There is also ALWAYS a backup
of the very FIRST input, retrieved by XXDEF. Neither of these have any meaning
except to (X)XDEF. Having done REMTEN,REMSYM,REMDEF thus makes a tensor
completely forgotten to both Sheep and Stensor, until you change your mind
and do XXDEF and TCOMP on it again.


DANGER WITH TENALIAS!*
Use internal names, or be aware of what TENALIAS!* you have (just type the
symbol to find out). Some Stensor images are built on Sheep-versions containing
specific application packages, and inherits TENALIAS!* -values from there.
If so, a warning message about "TENALIAS!* non-nil" is given at startup.
It is very easy to see what objects there are, by eg
(DSTAT ALL PRE tsr)	

PACKAGE symbol, if set, causes objects that are first introduced by being
PDEF-ined or <-created, get an internal name with the PACKAGE-symbol appended
to it.
If FORCEIT is on, also objects first seen through: <tsr...>, are given it
(ie normally the basic, input objects).

WARNINGS:
TCOMPOUT may overwrite previous .blf-file. This also applies to SAVDEF etc,
		and is due to OUTF doing so.

ALIAS-inhibition (by using 'tsr) doesn't always succeed, translation may
	still occur, since many commands "translate several times".
	Additional '' then might work, one being stripped per evaluation.


FORCEIT switch [off] overrides safetycatches in various situations:
	PACKET-symbol (if any) is put on all objects read.
	BUCKETOUT then forces overwrite of previous file,
		not mergeing as is default under batch.
	A gun is useful when hunting, but should be unloaded before returning
	home. Similarly you are adviced to turn off FORCEIT after use.

(TCOMPOUTIN file t1 t2...) loads file if on disk, else creates it with
	TCOMPOUT. In both events the result is that the memory contains
	bulf-programs for tensors t1,t2... as if TCOMPed.
	Useful in library files, which when first time loaded will call TCOMP
	but then also create a file.BLF. Next time, this file will simply be
	loaded, which may save some time, output and core (loading of TCOMP 
	might not have been done, and TCOMP will then stay out).
	To force update of the .blf-file, delete it, or turn on:
FORCEIT switch [off] that here cause TCOMPOUTIN to write anew no matter what.
	Ie makes TCOMPOUTIN identical to TCOMPOUT.

(LOADEF file) Loads file.DEF

(NEWISUL [nbr] sul [pred pred..])	Introduce New (Indicial) Subs-list
	-and call on SETSUB 
	-To make active, you MUST also type eg:
		(SETTSUP TSUL sul TSUL)
	You can either have nbr of substitutions, or have predicate.
	If you have both, all substitutions will take the same predicate.

(SETSUP sup sul1 sul2..)_ Set_ SUPer_ substitution list "sup" to (sul1..)
	Default: xSUP=(xSUL) with x=T,S,W.

SUP-er-lists and SETSUP are already explained in the *MANUAL* -see it!


(SETTSUP sul1 sul2..)	Short for SETSUP TSUP since it usually is the TSUP
			we want to set.



		HIERARCHY OF COMMUTATIVITY RESTRICTION COMMANDS

		---------------------------------------------------------------
ANTI	     /	DIFFOPERATOR,S/ABIDIFF.. As NEVER.. plus spreads over products
-COMMUTE    /	---------------------------------------------------------------
combines    |	NEVERCOMMUTE	unilateraly refuses to swap with anything else
with all    |	---------------------------------------------------------------
these,to   /	NEVERCOMMUTEBUT		initial excemptions, else as above.
give a	  <	COMMUTEWITH		additional  "
signchange \	---------------------------------------------------------------
*IF*	    |	NONCOMMUTE    (bi)  Mutual noncommutativity within a set only.
swapped     |	---------------------------------------------------------------
(bi-	    \	ALWAYSCOMMUTE (uni) Used on objects such as delta and epsilons.
 -lateral)   \			Overrides "NEVERCOMMUTE"-declared
-------------------------------------------------------------------------------
ELEMENTARY objects, with no STENSOR-properties, are already at input stored
in a different part of the term from those with, and given to Sheep to handle.
-------------------------------------------------------------------------------
